/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#ifndef __PDB_CLASS_FIELD_H__
#define __PDB_CLASS_FIELD_H__

#ifdef _OLD_HEADER_
# include <vector.h>
#else
# include <vector>
  using std::vector;
#endif
#include "pdbTemplateItem.h"

class pdbClassField : public pdbTemplateItem {
public:
  pdbClassField(const string& name) : pdbTemplateItem(name, -1), k(M_NA),
                ty(0), isBit(false), isMut(false), isSC(false) {}

  virtual const char *desc() const { return "class field"; }
  virtual const char *attrPrefix() const { return "cm"; }
  virtual ostream& print(ostream& ostr) const;

  mem_t kind() const { return k; }
  const pdbType *type() const { return ty; }
  bool isBitField() const { return isBit; }
  bool isMutable() const { return isMut; }
  bool isStaticConst() const { return isSC; }

  void kind(mem_t kd) { k = kd; }
  void type(const pdbType *t) { ty = t; }
  void isBitField(bool b) { isBit = b; }
  void isMutable(bool m) { isMut = m; }
  void isStaticConst(bool c) { isSC = c; }

private:
  mem_t              k;
  const pdbType     *ty;
  bool               isBit;
  bool               isMut;
  bool               isSC;
};

#endif
