/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#ifndef __PDB_FILE_H__
#define __PDB_FILE_H__

#include "pdbSimpleItem.h"

class pdbFile : public pdbSimpleItem {
public:
  pdbFile(int id) : pdbSimpleItem(id), n(0) {}
  pdbFile(const string& name, int id) : pdbSimpleItem(name, id), n(0) {}

  typedef vector<pdbFile *> incvec;

  virtual const char *desc() const { return "source file"; }
  virtual ostream& print(ostream& ostr) const;
  virtual void adjustPtrs(PDB* p);
  virtual void process(PDB* p);

  incvec& includes() { return i; }
  const incvec& includes() const { return i; }
  int numCalled() const { return n; }

  void addInclude(pdbFile *inc) { i.push_back(inc); inc->n++; }

private:
  incvec i;
  int    n;
};

#endif
