/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#include "pdbClassField.h"
#include "pdbClass.h"
#include "pdbType.h"

ostream& pdbClassField::print(ostream& ostr) const {
  const pdbClass *cl;

  ostr << "cmem " << name() << "\n";
  if ( location().file() )ostr << "cmloc " << location() << "\n";
  if ( const pdbClass* cptr = parentClass() ) {
    //ostr << "cmclass cl#" << cptr->id() << "\n";
    ostr << "cmacs " << toName(access()) << "\n";
  }
  ostr << "cmkind " << toName(kind()) << "\n";
  if ( (cl = type()->isClass()) != 0 )
    ostr << "cmtype " << "cl#" << cl->id() << "\n";
  else
    ostr << "cmtype " << "ty#" << type()->id() << "\n";
  pdbTemplateItem::print(ostr);
  if ( isStaticConst() ) ostr << "cmconst T\n";
  if ( isBitField() ) ostr << "cmisbit T\n";
  if ( isMutable() ) ostr << "cmmut T\n";
  return ostr;
}
