/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#include "pdbItem.h"

void pdbFile::process(PDB *p) {
  // if file wasn't included, add it to the toplevel files
  if ( numCalled() == 0 ) {
    p->fileTree()->addInclude(this);
  }
}

ostream& pdbFile::print(ostream& ostr) const {
  ostr << "so#" << id() << " " << name() << "\n";
  for (pdbFile::incvec::const_iterator it=i.begin(); it!=i.end(); ++it)
    ostr << "sinc so#" << (*it)->id() << "\n";
  return ostr << endl;
}

void pdbFile::adjustPtrs(PDB* p) {
  for (incvec::iterator it=i.begin(); it!=i.end(); ++it) {
    if ( (*it)->newId() > UNIQUE ) (*it) = p->getFileMap()[(*it)->newId()];
  }
}
