/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#include "pdbMacro.h"

ostream& pdbMacro::print(ostream& ostr) const {
  pdbItem::print(ostr);
  ostr << "mkind " << toName(kind()) << "\n";
  ostr << "mtext " << text() << "\n";
  return ostr << endl;
}

pdbSimpleItem::dupl_t pdbMacro::findDuplicate(pdbSimpleItem* r) {
  pdbMacro* rhs = dynamic_cast<pdbMacro*> (r);
  if ( fullName() == rhs->fullName() ) {
    pdbLoc ll = location();
    pdbLoc rl = rhs->location();
    if ( (ll.file() && rl.file()) && (ll.file()->name() == rl.file()->name()) &&
         (ll.line() == rl.line()) && (ll.col() == rl.col()) )
      return NEWDUPL;
    else
      return NODUPL;
  } else {
    return NODUPL;
  }
}
