/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#include "pdbSimpleItem.h"
#include "pdbFile.h"
#include "pdbRoutine.h"

ostream& operator<<(ostream& ostr, const pdbSimpleItem& i) {
  return i.print(ostr);
}

const char *pdbSimpleItem::attrPrefix() const {
  static char pre[2];

  pre[0] = desc()[0];
  pre[1] = '\0';

  return pre;
}

ostream& pdbLoc::printLoc(ostream& ostr) const {
  if ( const pdbFile *f = file() )
    ostr << "so#" << f->id();
  else
    ostr << "NULL";
  return ostr << " " << line() << " " << col();
}

ostream& operator<<(ostream& ostr, const pdbLoc& l) {
  return l.printLoc(ostr);
}

