/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#include "pdbTemplateItem.h"
#include "pdbTemplate.h"

const pdbTemplate* pdbTemplateItem::TE_UNKNOWN = (const pdbTemplate*)1;

ostream& pdbTemplateItem::print(ostream& ostr) const {
  const char *X = attrPrefix();

  if ( const pdbTemplate* tptr = isTemplate() ) {
    if ( tptr == TE_UNKNOWN )
      ostr << X << "templ T\n";
    else
      ostr << X << "templ te#" << tptr->id() << "\n";
    if ( isSpecialized() ) ostr << X << "specl T\n";
  }
  return ostr;
}

void pdbTemplateItem::adjustPtrs(PDB* p) {
  pdbFatItem::adjustPtrs(p);
  if ( t && (t != TE_UNKNOWN) && (t->newId() > UNIQUE) )
    t = p->getTemplateMap()[t->newId()];
}
