/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#ifdef _OLD_HEADER_
# include <fstream.h>
#else
# include <fstream>
  using std::ofstream;
#endif
#include "pdbAll.h"

void PDB::write(ostream& ostr) {
  ostr << "<PDB 1.0>\n\n";

  // One can use the following more simpler implementation
  // if printings all items in order is not necessary
  //
  // itemvec items = getItemVec();
  // for (itemvec::iterator it = items.begin(); it != items.end(); ++it)
  //   ostr << **it;

  filevec f = getFileVec();
  for (filevec::iterator fi = f.begin(); fi != f.end(); ++fi)
    ostr << **fi;

  typevec t = getTypeVec();
  for (typevec::iterator ty = t.begin(); ty != t.end(); ++ty)
    if ( !(*ty)->isClass() ) ostr << **ty;

  classvec c = getClassVec();
  for (classvec::iterator cl = c.begin(); cl != c.end(); ++cl)
    ostr << **cl;

  routinevec r = getRoutineVec();
  for (routinevec::iterator ro = r.begin(); ro != r.end(); ++ro)
    ostr << **ro;

  templatevec u = getTemplateVec();
  for (templatevec::iterator te = u.begin(); te != u.end(); ++te)
    ostr << **te;

  namespacevec n = getNamespaceVec();
  for (namespacevec::iterator na = n.begin(); na != n.end(); ++na)
    ostr << **na;

  macrovec m = getMacroVec();
  for (macrovec::iterator ma = m.begin(); ma != m.end(); ++ma)
    ostr << **ma;
}

bool PDB::write(char *fname) {
  ofstream of(fname);
  if (!of) {
    cerr << "Error: Cannot open '" << fname << "'" << endl;
    return false;
  }
  write(of);
  return true;
}
