/*************************************************************************/
/* DUCTAPE Version 1.0                                                   */
/* Copyright (C) 1998                                                    */
/* Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik */
/* Los Alamos National Laboratory, Advanced Computing Laboratory         */
/*************************************************************************/

#include <unistd.h>
#include "pdb.h"

int main(int argc, char *argv[]) {
  int ch;
  char *outfile = 0;
  bool errflag = argc < 3;

  while ( (ch = getopt(argc, argv, "o:v")) != -1 ) {
    switch (ch) {
    case 'o': outfile = optarg;
              break;
    case '?': errflag = true;
              break;
    }
  }
  if ( errflag ) {
    cerr << "usage: " << argv[0] << " [-o outfile] pdbfile..." << endl;
    return 1;
  }

  if ( outfile ) cout << "opening " << argv[optind] << " ..." << endl;
  PDB pdb(argv[optind++]);

  if ( pdb ) {
    for (; optind<argc; ++optind) {
      if ( outfile ) cout << "merging " << argv[optind] << " ..." << endl;
      if ( ! pdb.merge(argv[optind]) ) return 1;
    }
  }
  if ( outfile ) {
    cout << "writing " << outfile << " ..." << endl;
    pdb.write(outfile);
  } else
    pdb.write(cout);
  return 0;
}
